function [ dkf ] = hofd( f , x0 , step , k )
%HOFD Higher order finite differences
% [ dkf ] = hofd( f , x0 , step , k )

% recursive definition: Doesn't work yet... FIXME!
if numel(step)==1; 
    if k == 0; 
        dkf = f(x0); 
    elseif k == 1; 
        dkf = fd(f,x0,step); 
    else 
        dkf = (hofd(f,x0+step,step,k-1) - hofd(f,x0,step,k-1))/step; 
    end; 
else
    % use different step sizes at outer/inner
    if k == 0; 
        dkf = f(x0); 
    elseif k == 1; 
        fprintf('First-order derivative; Step: %5.3f.\n',step(k)); 
        dkf = fd(f,x0,step(k)); 
    else 
        dkf = (hofd(f,x0+step(k),step(k),k-1) - hofd(f,x0,step(k),k-1))/step(k); 
    end; 
end; 
    
    
end

