function [ ll , grad , hess ] = ll_rclogit_black( theta , data , mp )
%LL_RCLOGIT Summary of this function goes here
%   Detailed explanation goes here

global fctCount

fctCount = fctCount+1; 

% utilities
v = data.z*reshape(theta,[mp.D,mp.K])*data.x/mp.lambda; 
logsum = log(sum(exp(v),2)); 

% CCPs
ll = v(data.choiceIdx)' - logsum; 

% ### FINITE DIFFERENCES ### 
relStep = 1e-8; 
t0 = theta; 
t0(t0==0) = 1; 
% keyboard; 
ll2 = nan(mp.N,mp.K); 
for iK=1:mp.K
    iota = zeros(1,mp.K); 
    iota(iK) = 1; 
    % Likelihood evaluation (using the normal function)
    ll2(:,iK) = ll_rclogit(theta + relStep*iota.*theta,data,mp); 
end;

% Compute the gradient
gradFull = (ll2 - ll(:,ones(1,mp.K)))./(relStep*theta(ones(mp.N,1),:)); 
if nargout == 3; 
    hess = mp.N^-1 * (gradFull'*gradFull); 
end; 

% Switch to negative, mean log like
grad = -mean(gradFull,1); 
ll = -mean(ll); 

end

