function [ f_diff , noise ] = simple_diff( fhandle , x0 , h , k )
%SIMPLE_DIFF Summary of this function goes here
%   Detailed explanation goes here
% keyboard; 

if k==0; 
    f_diff = fhandle(x0); 
    gamma_k = nan; 
elseif k==1; 
    gamma_k = 0.5; 
    f_diff = fhandle(x0 + .5*h) - fhandle(x0 - .5*h);     
else
    temp = nan(k,1); 
    if mod(k,2) == 1; % odd
        vals = -floor(k/2):floor(k/2); 
    else % even
        vals = -floor(k/2)-.5:floor(k/2)+.5; 
    end; 
    
    % --- Main calculations --- 
    % Compute gamma
    gamma_k =  factorial(k)^2 / factorial(2*k); 
    
    % Construct difference table
    for i=1:k; 
        temp(i) = fhandle(x0 + h*vals(i));
    end;     
    for i=k:-1:2; 
        temp(1:i-1) = diff(temp(1:i)); 
    end;     
    f_diff = temp(1); 
end; 

if nargout == 2; 
    noise = sqrt(gamma_k * f_diff^2); 
end; 

end

